#!/usr/bin/perl
#-----------------------------------------------------------------------
# content.cgi - retrieve content from the database for viewing
#-----------------------------------------------------------------------

use strict;
use ExSite::Config;
use ExSite::DB;
use ExSite::Page;
use ExSite::Input;
use ExSite::ContentData;
#use ExSite::Misc;

use vars qw($db %q);

&exsite_init;
$db = new ExSite::DB;
my $in = new ExSite::Input;
my $query = $in->query();
my %q = %$query;

if ($q{id}) {
    if ($db->referer_check()) {
	my $c = new ExSite::ContentData(id=>$q{id});
	$c->set_context();
	if (&authorize($c)) {
	    my $type = $c->content_type;
	    print "Content-type: $type\n\n";
	    if ($type =~ /text\/html/) {
		$share{Page} = new ExSite::Page(page=>$c->get("page"));
		print $c->expand;  # show oysters
	    }
	    elsif ($q{thumb}) {
		$c->set_context;
		my $data = $c->get_thumb_raw;
		print $data ? $data : $c->get_raw;
	    }
	    else {
		print $c->get_raw;
	    }
	}
	else {
	    &deny();
	}
    }
    else {
	print "Content-type: text/plain\n\n \n";
    }
}
else {
    print "Content-type: text/plain\n\nNo content to display!\n";
}

sub authorize {
    my $c = shift;
    if ($c->get_my("ptime") =~ /^0/) {
	if ($share{DB}->is_manager($c->get("section"))) {
	    # we're an admin, approve
	    return 1;
	}
	else {
	    # unpublished content on live site
	    $c->warn("Live unpublished content (content ID ".$c->id.")");
	    return 0 if $config{content}{block_unpublished};
	}
    }
    # approve if we are permitted to view this page/library
    my $p = new ExSite::Page(page=>$c->get("page"));
    return $p->authorize();
}

sub deny {
    my $ml = &get_obj("ML");
    $ml->Doctype($config{doctype});
    $ml->Doc($ml->p("Permission denied &mdash; redirecting to login screen..."));
    $ml->__body();
    my $this_url = $config{server}{server}.$ENV{REQUEST_URI};
    my $login_url = "$config{server}{CGIpath}/$config{prog}{login}?goto=$this_url";
    $ml->Prepend(
		 $ml->head(
			   $ml->title("Permission denied").
			   $ml->meta(undef,{'http-equiv'=>"Refresh",
					    content=>"3;URL=$login_url"}).
		     $ml->link(undef,{rel=>"stylesheet", type=>"text/css", href=>"$config{server}{HTMLpath}/_ExSite/css/ExSite.css"})
	)
	);
    $ml->__html();
    print "Content-type: text/html\n\n";
    $ml->Print();
    # above is just a fancy version of this:
    #print "Location: $config{server}{server}$config{server}{CGIpath}/$config{prog}{login}?goto=$config{server}{server}$ENV{REQUEST_URI}\n\n";
}
