tinymce.PluginManager.add('grid', function(editor, url) {
	editor.addMenuItem('grid_list',{
		text: 'Grid',
		context : 'format',
		menu : [
			{text:'2',onclick: function() {addGrid(2);}},
			{text:'4',onclick: function() {addGrid(4);}},
			{text:'6',onclick: function() {addGrid(6);}},
			{text:'8',onclick: function() {addGrid(8);}},
			{text:'9',onclick: function() {addGrid(9);}},
			{text:'12',onclick: function() {addGrid(12);}}
		]
	});
	editor.addMenuItem('grid_add', {
		text: 'Grid Item',
		tooltip: 'Add grid item',
		onclick: function(){
			var nodeSel = parent.tinymce.activeEditor.selection.getNode();
			if (inGrid(nodeSel) == 0){
				alert('Cursor is not in a grid');
				return;
			}
			var n = findGrid(nodeSel);
			if (n == 0){
				alert('Cursor is not in a grid');
				return;
			}
			if (n.className == 'responsiveGridItem' && n.nextSibling != null){
				n.parentNode.insertBefore(newGridItem(),n.nextSibling);
			}else if (n.className == 'responsiveGrid'){
				n.appendChild(newGridItem());
			}else if (n.nextSibling == null){
				n.parentNode.appendChild(newGridItem());
			}
		}
	});
	function findGrid(node){
		var nod = null;
		while (node != null && node.tagName != 'BODY'){
			if (node.className == 'responsiveGrid' || node.className == 'responsiveGridItem'){
				nod = node;
				break;
			}
			node = node.parentNode;
		}
		return nod;
	}
	function newGridItem(){
		var gItem = document.createElement('div');
		gItem.setAttribute('class','responsiveGridItem');
		gItem.innerHTML = '&nbsp;';
		return gItem;
	}
	function inGrid(node){
		if (node == null || node.tagName == 'BODY'){
			return 0;
		}
		var in_grid = 0;
		while (node != null && node.tagName != 'BODY'){
			if (node.className == 'responsiveGrid' || node.className == 'responsiveGridItem'){
				in_grid = 1;
				break;
			}
			node = node.parentNode;
		}
		return in_grid;
	}
	function addGrid(num){
		if (inGrid(parent.tinymce.activeEditor.selection.getNode()) == 1){
			alert('You can not insert a grid within a grid');
			return;
		}
		var _grid = document.createElement("div");
		_grid.setAttribute('class','responsiveGrid');
		for(var i = 0; i < num; i++){
			_grid.appendChild(newGridItem());
		}
		editor.execCommand('mceInsertContent',false,_grid.outerHTML);
	}
});
